Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/PermissionsPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/PermissionsPanel.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/PermissionsPanel.java	(revision 41638)
@@ -0,0 +1,131 @@
+
+package org.gvsig.exportto.swing.prov.jdbc.panel;
+
+import javax.swing.JComponent;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.exportto.swing.prov.jdbc.ExporttoJDBCOptions;
+import org.gvsig.exportto.swing.spi.ExporttoPanelValidationException;
+import org.gvsig.exportto.swing.spi.ExporttoSwingProviderPanel;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.i18n.I18nManager;
+
+
+public class PermissionsPanel extends PermissionsPanelLayout implements ExporttoSwingProviderPanel {
+    private static final long serialVersionUID = -1930610404012797310L;
+
+    private ExporttoJDBCOptions provider;
+
+    public PermissionsPanel(ExporttoJDBCOptions provider) {
+        this.provider = provider;
+        initComponents();
+    }
+
+    private void initComponents() {
+    }
+
+    public String getPanelTitle() {
+        I18nManager i18nManager = ToolsLocator.getI18nManager();
+        return i18nManager.getTranslation("Permissions");    
+    }
+
+    public boolean isValidPanel() throws ExporttoPanelValidationException {
+        return true;
+    }
+    
+    public void enterPanel() {
+        // Default do nothing
+    }
+    
+    public JComponent asJComponent() {
+        return this;
+    }
+
+    public String getSelectRole() {
+        if( !this.chkSelect.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleSelect.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+    public String getInsertRole() {
+        if( !this.chkSelect.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleSelect.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+    public String getUpdateRole() {
+        if( !this.chkUpdate.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleUpdate.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+    public String getDeleteRole() {
+        if( !this.chkDelete.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleDelete.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+    public String getTruncateRole() {
+        if( !this.chkTruncate.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleTruncate.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+    public String getReferenceRole() {
+        if( !this.chkReference.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleReference.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+    public String getTriggerRole() {
+        if( !this.chkTrigger.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleTrigger.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+    public String getAllRole() {
+        if( !this.chkAll.isSelected() ) {
+            return null;
+        } 
+        String role = this.txtRoleAll.getText();
+        if( StringUtils.isBlank(role) ) {
+            return null;
+        }
+        return role.trim();
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporttoJDBCOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporttoJDBCOptions.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporttoJDBCOptions.java	(revision 41638)
@@ -6,8 +6,8 @@
 
 package org.gvsig.exportto.swing.prov.jdbc;
 
+import java.util.List;
 import org.cresques.cts.IProjection;
-import org.gvsig.exportto.swing.spi.ExporttoSwingProvider;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
 
@@ -45,4 +45,25 @@
     
     public IProjection getTargetProjection();
     
+    public String getSelectRole();
+    
+    public String getInsertRole();
+    
+    public String getUpdateRole();
+    
+    public String getDeleteRole();
+    
+    public String getTruncateRole();
+    
+    public String getReferenceRole();
+    
+    public String getTriggerRole();
+    
+    public String getAllRole();
+    
+    public String getPostCreatingStatement();
+    
+    public boolean getCreateIndexInGeometryRow();
+    
+    public boolean getUpdateTableStatistics();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporrtoJDBCService.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporrtoJDBCService.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporrtoJDBCService.java	(revision 41638)
@@ -116,6 +116,11 @@
             }
         }
 
+        if( this.options.getCreateIndexInGeometryRow() ) {
+            EditableFeatureAttributeDescriptor x = (EditableFeatureAttributeDescriptor)targetEditableFeatureType.getDefaultGeometryAttribute();
+            x.setIsIndexed(true);
+        }
+        
         // ======================================================
         // Reprojection: set SRS of geometry field to target SRS
         EditableFeatureAttributeDescriptor attrdescriptor
@@ -272,6 +277,10 @@
             }
             targetFeature = null;
             target.finishEditing();
+            
+            if( this.options.getUpdateTableStatistics() ) {
+                explorer.updateTableStatistics(openParams.tableID());
+            }
 
             if (exporttoServiceFinishAction != null) {
                 exporttoServiceFinishAction.finished(
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProvider.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProvider.java	(revision 41638)
@@ -30,8 +30,12 @@
 import org.cresques.cts.IProjection;
 import org.gvsig.exportto.ExporttoService;
 import org.gvsig.exportto.swing.prov.jdbc.panel.CheckGeometriesPanel;
+import org.gvsig.exportto.swing.prov.jdbc.panel.GeometryIndexPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.IdentifiersOptionsPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.JDBCConnectionPanel;
+import org.gvsig.exportto.swing.prov.jdbc.panel.UpdateTableStatisticsPanel;
+import org.gvsig.exportto.swing.prov.jdbc.panel.PermissionsPanel;
+import org.gvsig.exportto.swing.prov.jdbc.panel.PostCreatingStatementPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.SelectPkPanel;
 import org.gvsig.exportto.swing.prov.jdbc.panel.SelectTableNamePanel;
 import org.gvsig.exportto.swing.spi.ExporttoSwingProvider;
@@ -71,9 +75,14 @@
     private final SelectTableNamePanel selectTableNamePanel;
     private final CheckGeometriesPanel checkGeometriesPanel;
     private final IdentifiersOptionsPanel identifiersOptionsPanel;
+    
+    private final GeometryIndexPanel geometryIndexPanel;
+    private final UpdateTableStatisticsPanel updateTableStatistics;
+    private final PermissionsPanel permissionsPanel;
+    private final PostCreatingStatementPanel postCreatingStatementPanel;
 
     private String storeName = null;
-
+    
     public BaseExporttoJDBCProvider(ProviderServices providerServices,
             FeatureStore sourceStore, IProjection projection) {
         super(providerServices);
@@ -92,12 +101,23 @@
         this.selectPkPanel = new SelectPkPanel(this);
         this.checkGeometriesPanel = new CheckGeometriesPanel(this);
         this.identifiersOptionsPanel = new IdentifiersOptionsPanel(this);
+        
+        this.geometryIndexPanel = new GeometryIndexPanel(this);
+        this.updateTableStatistics = new UpdateTableStatisticsPanel(this);
+        this.permissionsPanel = new PermissionsPanel(this);
+        this.postCreatingStatementPanel = new PostCreatingStatementPanel(this);                
 
         this.panels.add(this.identifiersOptionsPanel);
         this.panels.add(this.connectionPanel);
         this.panels.add(this.selectTableNamePanel);
         this.panels.add(this.selectPkPanel);
+        this.panels.add(this.geometryIndexPanel);        
         this.panels.add(this.checkGeometriesPanel);
+        
+        this.panels.add(this.permissionsPanel);
+        this.panels.add(this.updateTableStatistics);
+        this.panels.add(this.postCreatingStatementPanel);
+        
     }
 
     public int getPanelCount() {
@@ -187,5 +207,48 @@
         return this.projection;
     }
 
+    public String getSelectRole() {
+        return this.permissionsPanel.getSelectRole();
+    }
+
+    public String getInsertRole() {
+        return this.permissionsPanel.getInsertRole();
+    }
+
+    public String getUpdateRole() {
+        return this.permissionsPanel.getUpdateRole();
+    }
+
+    public String getDeleteRole() {
+        return this.permissionsPanel.getDeleteRole();
+    }
+
+    public String getTruncateRole() {
+        return this.permissionsPanel.getTruncateRole();
+    }
+
+    public String getReferenceRole() {
+        return this.permissionsPanel.getReferenceRole();
+    }
+
+    public String getTriggerRole() {
+        return this.permissionsPanel.getTriggerRole();
+    }
+
+    public String getAllRole() {
+        return this.permissionsPanel.getAllRole();
+    }
+
+    public String getPostCreatingStatement() {
+        return this.postCreatingStatementPanel.getPostCreatingStatement();
+    }
+
+    public boolean getCreateIndexInGeometryRow() {
+        return this.geometryIndexPanel.getCreateIndexInGeometryRow();
+    }
+
+    public boolean getUpdateTableStatistics() {
+        return this.updateTableStatistics.getUpdateTableStatistics();
+    }
     
 }
